*****************************************************************************
* Name:         Built-in Game Launcher Aplet for the HP39/40G
* Language:     RPL
* Author:       Jordi Hidalgo (johil@tv3mail.com)
* Copyright:    (c) 2002 by Jordi Hidalgo Lozano. All rights reserved.
* Versions:     1.0 September 15, 2002
*               1.1 October 22, 2002
*               1.2 February 19, 2003
*****************************************************************************

TITLE GameLauncher

INCLUDE common39.h

ASSEMBLE
        Dir_Head 13,Game Launcher,601
RPL

EXTERNAL view7_CAPLET

{
 topic_CAPLET
 view01_CAPLET
 view23_CAPLET
 view45_CAPLET
 xREADNOTE
 view7_CAPLET
}

INCLUDE share39.h

ASSEMBLE
        Vfield  L34,IntTable
        CON(5)  =DOHSTR
        REL(5)  endLink
        Link    _Main
        Link    _Play
endLink
RPL

DEFINE  Main            INT_00
DEFINE  Play            INT_01
DEFINE  CfgVars         LastBut3

ASSEMBLE
        Vfield  IntTable,DirVar
RPL
ASSEMBLE
        CON(5)  =DOHSTR
        REL(5)  endCode
RPL

ASSEMBLE
=PURGEOB        EQU     #09550
=GOTO           EQU     #0D594
=Ck&DoMsgBox    EQU     #3F327
=DoTetris       EQU     #3F921
=DoDyna         EQU     #3F923
=DoSkwik        EQU     #5D5C2 (8)
=DoXennon       EQU     #69FDE (8)
=DoArkanoiid    EQU     #750CF (8)
RPL

NAMELESS _Main
::
 {
  MINUSONE
  {
   { $ "Start" :: ZERO INT_00 ; }
   { $ "About" NotesViewUI }
  }
  StndVar
  StndReset
  StndEntry
  StndExit
 }
 BinLookup case EVAL DROP
 '
 ::
  '
  ::
   SIXTY #=casedrop TrueTrue
   SIXTYEIGHT #=casedrop
   ::
    DUP ONE #=case
    ::
     SWAP
     {
      FIFTYONE
      :: Play ;
      BINT21
      ::
       TakeOver
       TOLVar8@
       DUP THREE #< casedrop DoBadKey
       DUP
       LESetItem
       CARCOMP
       $ "Reset game " SWAP&$ "?" &$
       DoQueryBox
       NOTcaseDROP
       CfgVars
       CONTEXT@ HOMEDIR
       SWAPROT #2- NTHCOMPDROP
       @ ' PURGEOB RPIT
       CONTEXT!
      ;
     }
     #=Lookup
     case
     ::
      SWAPDROP
      TrueTrue
     ;
     SWAP FALSE
    ;
    DUP TWO #=case
    ::
     SWAP
     {
      BINT21
      ::
       TakeOver
       $ "Reset all games?"
       DoQueryBox
       NOT?SEMI
       CfgVars
       CONTEXT@ HOMEDIR
       SWAP INNERCOMP
       ZERO_DO (DO)
        @ ' PURGEOB RPIT
       LOOP
       CONTEXT!
      ;
     }
     #=Lookup
     case
     ::
      SWAPDROP
      TrueTrue
     ;
     SWAP FALSE
    ;
    FALSE
   ;
   FIVETHREE #=casedrop
   ::
    '
    ::
     NoExitAction
     {
      NullMenuKey
      NullMenuKey
      {

       ASSEMBLE
        CON(5)  =DOGROB
        CON(5)  #3F
        CON(5)  #8
        CON(5)  #16
        NIBHEX  000000FFFFF3FFB2A3FF5BA3FFA3A3FF5BB3FFBA32FFFFF3
       RPL
       :: Play ;
      }
      {
       ASSEMBLE
        CON(5)  =DOGROB
        CON(5)  #3F
        CON(5)  #8
        CON(5)  #15
        NIBHEX  000000FFFFF1DAAFF1AA5FF18DBEF1AD5FF1ADAFF1FFFFF1
       RPL
       :: Play ;
      }
      NullMenuKey
      NullMenuKey
     }
    ;
    TRUE
   ;
   DROPFALSE
  ;
  $ "Game Launcher"
  SEVENTEEN
  {
   :: $ "Tetris" DoTetris DECOMP$ $ "Score: " SWAP&$ Ck&DoMsgBox ;
   :: $ "Dyna Blaster" DoDyna ;
   :: $ "Skwik" GOTO DoSkwik ;
   :: $ "Xennon" GOTO DoXennon ;
   :: $ "Arkanoiid" GOTO DoArkanoiid ;
  }
  ONE
  ChooseVEntry
 ;
 '
 :: ChooseVExit DROP ;
 ChooseViewUI
;

NAMELESS _Play
::
 TakeOver
 TOLVar8@
 LESetItem
 CDRCOMP
 DUP CARCOMP ' GOTO EQITE
 ASSEMBLE
        NIBHEX  577208000000
 RPL
 EVAL
 FLUSHKEYS
;

ASSEMBLE
endCode
RPL

ASSEMBLE
        Vfield DirVar,DirCode
RPL
{
 ID _fp_SKWIK
 ID XENNON
 ID _fp_ARKA
}

ASSEMBLE
        Vfield DirCode,DirAlt
RPL
{ }

ASSEMBLE
        Vfield DirAlt,DirNot
RPL
$ " Aplet that launches\n the built-in games.\n\n    Jordi Hidalgo\n <johil@tv3mail.com>\n       (C) 2002"

ASSEMBLE
        Vfield DirNot,DirEnd
RPL
{ }
